<?php

require_once("switch/raslog.php");
require_once("switch/logging.php");
require_once("switch/logconfig.php");
class Host {

        var $vc;
        var $mor;
        var $host;
        var $inited;

        function Host($vc, $mor)
        {
                $this->vc     = $vc;
                $this->mor   = $mor;
                $this->inited = 0;
                return        $this;
        }
        function retrieveProperties()
        {

                unset($ps); unset($os); unset($rp);
                $ps = new PropertySet($this->vc, array(
                                              array('type' => 'HostSystem',
                                                    'all' => 'false',
                                                    "config.network.dnsConfig.hostName",
                                                    "config.network.dnsConfig.domainName",
                                                    "config.network.pnic",
                                                    "config.network.vswitch",
                                                    "config.network.portgroup",
                                                    "config.network.proxySwitch",
                                                    "config.network.vnic",
                                                    "config.network.consoleVnic",
                                                    "vm",
                                                    "summary.config.product.version",
                                                    "config.virtualNicManagerInfo.netConfig"
                                                                     )
                                              )
                        );
                $os = new ObjectSet($this->vc, array(
                                            array('type' => 'HostSystem', 'value' => $this->mor)
                                            )
                        );
                $rp = RetrieveProperties($this->vc, $ps->propSet, $os->objectSet);
                if (isset($rp['faultcode'])) {
                    raslogv(VCLOG_TRACE, "SOAP Fault");
                    raslogv(VCLOG_TRACE, $rp);
                        return 0;
                }
                $this->host    = $rp;
                raslogv(VCLOG_TRACE, "retrieve Properties HOSTS");
                raslogv(VCLOG_TRACE, $rp);
                return 1;
        }
        function getVersion()
        {
                $ret = getNodeValue($this->host, "summary.config.product.version");
                return urldecode($ret);
        }
        function getVMS()
        {
                $ret = getNodeValue($this->host, "vm");
                $ss = $ret['ManagedObjectReference'];
                return make_array($ss);
        }
        function getPnics()
        {
                $ret = getNodeValue($this->host, "config.network.pnic");
                return make_array($ret['PhysicalNic']);
        }

        function getVnics()
        {
                $ret = getNodeValue($this->host, "config.network.vnic");
                return make_array($ret['HostVirtualNic']);
        }

        function getProxySwitch()
        {
                $ret = getNodeValue($this->host, "config.network.proxySwitch");
                return make_array($ret['HostProxySwitch']);
        }

        function getvSwitch()
        {
                $ret = getNodeValue($this->host, "config.network.vswitch");
                return make_array($ret['HostVirtualSwitch']);
        }

        function getPortGroup()
        {
                $ret = getNodeValue($this->host, "config.network.portgroup");
                return make_array($ret['HostPortGroup']);
        }

        function getHostFQDN()
        {

                $hName = getNodeValue($this->host, "config.network.dnsConfig.hostName");
                $dName = getNodeValue($this->host, "config.network.dnsConfig.domainName");

                $fqdn = $hName . "." . $dName;
                return urldecode($fqdn);
        }
        function getConsoleVnic()
        {
                $ret = getNodeValue($this->host, "config.network.consoleVnic");
                return make_array($ret['HostVirtualNic']);
        }
        function getVnicsType()
        {
                $ret = getNodeValue($this->host, "config.virtualNicManagerInfo.netConfig");
                $nic_types = $ret['VirtualNicManagerNetConfig'];
                unset($ret);
                foreach ($nic_types as $nic_type) {
                    $type = $nic_type['nicType'];
                    $selectedVnics = $nic_type['selectedVnic'];
                    unset($device);
                    $nics = $nic_type['candidateVnic'];
                    if (!empty($nics)) {//some vmknics are defined
                        if (empty($nics['device'])) {//multiple vmknics
                            foreach ($nics as $nic) {
								$key = $nic['key'];
								
                                if(is_array($selectedVnics)){
							    if(!empty($selectedVnics)&&in_array($key,$selectedVnics))		                
                                   $device[] = $nic['device'];
                                }else{
                                   if(strcmp($key,$selectedVnics)==0)
									$device[] = $nic['device'];
								}
                            }
                        } else {//only one vmknic
								$key = $nic['key'];
								 if(is_array($selectedVnics)){
                                if(!empty($selectedVnics)&&in_array($key,$selectedVnics))
                                   $device[] = $nic['device'];
                                }else{
                                   if(strcmp($key,$selectedVnics)==0)
                                    $device[] = $nic['device'];
                                }

                        }
                    }
                    $ret[$type] = $device;
                }
                return $ret;
        }
}
class VM {

        var $vc;
        var $mor;
        var $vm;
        var $inited;

        function VM($vc, $mor)
        {
                $this->vc     = $vc;
                $this->mor   = $mor;
                $this->inited = 0;
                return        $this;
        }
        function retrieveProperties()
        {
                unset($ps); unset($os); unset($rp);
                $ps = new PropertySet($this->vc, array(
                                              array('type' => 'VirtualMachine',
                                                    'all' => 'false',
                                                    //"config",
                                                    "config.name",
                                                    "config.template",
                                                    "config.hardware.device",
                                                    "runtime.powerState",
                                                    "guest.net"                 )));
                $os = new ObjectSet($this->vc, array(
                                            array('type' => 'VirtualMachine', 'value' => $this->mor)
                                            )
                        );
                $rp = RetrieveProperties($this->vc, $ps->propSet, $os->objectSet);
                if (isset($rp['faultcode'])) {
                    raslogv(VCLOG_TRACE, "SOAP Fault");
                    raslogv(VCLOG_TRACE, $rp);
                        return 0;
                }
                $this->vm    = $rp;
                //print_r($rp);
                raslogv(VCLOG_TRACE, "retrieveProperties VMs");
                raslogv(VCLOG_TRACE, $rp);
                return 1;
        }
        function isTemplate()
        {
                $ret = getNodeValue($this->vm, "config.template");
                //return $ret;
            return ($ret==1)?"true":"false";
        }
        function getNN()
        {
                $ret = getNodeValue($this->vm, "config.name");
                return urldecode($ret);
        }
        function getVnicsName()
        {
                unset($names);
                $ret = getNodeValue($this->vm, "config.hardware.device");
                $vdevs = $ret['VirtualDevice'];
                foreach ($vdevs as $vdev) {
                        if ($vdev['key'] >= 4000 && $vdev['key'] < 4020) {
                                $names[] = $vdev['deviceInfo']['label'];
                        }
                }
                return $names;
        }
        function getVnicsMac()
        {
                unset($macs);
                $ret = getNodeValue($this->vm, "config.hardware.device");
                $vdevs = $ret['VirtualDevice'];
                foreach ($vdevs as $vdev) {
                        if ($vdev['key'] >= 4000 && $vdev['key'] < 4020) {
                                $macs[] = $vdev['macAddress'];
                        }
                }
                return $macs;
        }
        function getVnicsPgMor()
        {
                unset($pgs);
                $ret = getNodeValue($this->vm, "config.hardware.device");
                $vdevs = $ret['VirtualDevice'];
                foreach ($vdevs as $vdev) {
                        if ($vdev['key'] >= 4000 && $vdev['key'] < 4020) {
                                unset($temp);
                                $temp = $vdev['backing']['port']['portgroupKey'];
                                if (!empty($temp)) {
                                    //vnic on dvs
                                    $pgs[] = $temp;
                                } else {
                                    //vnic on vswitch
                                    $pgs[] = "key-vim.host.PortGroup-".$vdev['backing']['deviceName'];
                                }
                        }
                }
                return $pgs;
        }
        function getVnicsPgName()
        {
                unset($pgs);
                $ret = getNodeValue($this->vm, "config.hardware.device");
                $vdevs = $ret['VirtualDevice'];
                foreach ($vdevs as $vdev) {
                        if ($vdev['key'] >= 4000 && $vdev['key'] < 4020) {
                            unset($temp);
                            $temp = $vdev['backing']['port']['portgroupKey'];
                            if (!empty($temp)) {
                                //vnic on dvs
                                $pgs[] = "@"; 
                            } else {
                                //vnic on vswitch
                                $pgs[] = $vdev['deviceInfo']['summary'];
                            }
                        }
                }
                return $pgs;
        }
        function getPortId()
        {
                unset($pg);
                $ret = getNodeValue($this->vm, "config.hardware.device");
                $vdevs = $ret['VirtualDevice'];
                foreach ($vdevs as $vdev) {
                        if ($vdev['key'] >= 4000 && $vdev['key'] < 4020) {
                                $pg = $vdev['backing']['port']['portKey'];
                                if (empty($pg))
                                        $pg = $vdev['backing']['deviceName'];
                        }
                }
                return $pg;
        }

        function getVmIp()
        {
            unset($ip);
            $ret = getNodeValue($this->vm, "guest.net");
            $ips = $ret['GuestNicInfo'];
            $result = array();
            foreach ($ips as $ip) {
                $result[] = $ip['ipAddress'];
            }

            return $result;
        }
        function getVmPowerStatus()
        {
            unset($power);
            $power = getNodeValue($this->vm, "runtime.powerState");
            return $power;
        }
}
class dvSwitch {

        var $vc;
        var $mor;
        var $dvs;
        var $inited;

        function dvSwitch($vc, $mor)
        {
                $this->vc     = $vc;
                $this->mor    = $mor;
                $this->inited = 0;

                return $this;
        }
        function retrieveProperties()
        {
                unset($ps); unset($os); unset($rp);
                $vc = $this->vc;
                $ps = new PropertySet($this->vc, array(
                                              array('type' => 'VmwareDistributedVirtualSwitch',
                                                    'all' => 'false',
                                                    "config.name",
                                                    "config.uplinkPortgroup",
                                                    "config.host"
                                                                     )));
                $os = new ObjectSet($vc, array(
                                            array('type' => 'VmwareDistributedVirtualSwitch', 'value' => $this->mor)
                                            )
                        );
                $rp = RetrieveProperties($vc, $ps->propSet, $os->objectSet);
                if (isset($rp['faultcode'])) {
                    raslogv(VCLOG_TRACE, "SOAP Fault");
                    raslogv(VCLOG_TRACE, $rp);
                        return 0;
                }
                $this->dvs    = $rp;
                raslogv(VCLOG_TRACE, "retrieveProperties DVS");
                raslogv(VCLOG_TRACE, $rp);
                return 1;
        }
        function getNN()
        {
                $ret = getNodeValue($this->dvs, "config.name");
                return urldecode($ret);
        }
        function getHosts()
        {
                $ret = getNodeValue($this->dvs, "config.host");
                return make_array($ret['DistributedVirtualSwitchHostMember']);
        }
        function getUplinkPortGroupMOR()
        {
                $ret = getNodeValue($this->dvs, "config.uplinkPortgroup");
                return $ret['ManagedObjectReference'];
        }
}
function getDvsHostPnics($dvshost)
{
        /* Verify XXX */
        unset($name);
        $config = $dvshost['config'];
        if (is_array($config)) {
           $backing = $config['backing'];
           $name = $backing['pnicSpec'];
        } else {
           $backing = $config['backing'];
           $name = $backing['pnicSpec'];
        }
        return $name;
}
function getDvsHostMOR($dvshost)
{
    if (is_array($dvshost)) {
       $mor = $dvshost['config']['host'];
    } else {
      $mor = $dvshost['host'];
    }
    return $mor;
}

class dvpg {
        var $vc;
        var $mor;
        var $dvpg;
        var $inited;

        function dvpg($vc, $mor)
        {
                $this->vc     = $vc;
                $this->mor    = $mor;
                $this->inited = 0;
                return $this;
        }
        function retrieveProperties()
        {
                unset($ps); unset($os);
                $vc = $this->vc;
                $ps = new PropertySet($this->vc, array(
                                              array('type' => 'DistributedVirtualPortgroup',
                                                    'all' => 'false',
                                                    "config.name",
                                                    "config.distributedVirtualSwitch",
                                                    "config.defaultPortConfig",
                                                    "tag"
                                                                     )));
                $os = new ObjectSet($vc, array(
                                            array('type' => 'DistributedVirtualPortgroup', 'value' => $this->mor)
                                            )
                        );
                $rp = RetrieveProperties($this->vc, $ps->propSet, $os->objectSet);
                if (isset($rp['faultcode'])) {
                    raslogv(VCLOG_TRACE, "SOAP Fault");
                    raslogv(VCLOG_TRACE, $rp);
                    return 0;
                }
                raslogv(VCLOG_TRACE, "retrieveProperties DVPGS ");
                raslogv(VCLOG_TRACE, $rp);
                //print_r($rp);
                // ZZZ check error codes
                $this->dvpg   = $rp;
                return $rp;
        }
        function isUplinkPortGroup()
        {
                $ret = getNodeValue($this->dvpg, "tag");
                if (empty($ret)){
                        return "regular";
                } else {
                        return "uplink";
                }
        }
        function getNN()
        {
                $ret = getNodeValue($this->dvpg, "config.name");
                return urldecode($ret);
        }
        function getDvSwitch()
        {
                $ret = getNodeValue($this->dvpg, "config.distributedVirtualSwitch");
                return $ret;
        }
        function getDefaultPortConfig()
        {
                $ret = getNodeValue($this->dvpg, "config.defaultPortConfig");
                return $ret;
        }
        function getDefaultVlan()
        {
                $cfg = $this->getDefaultPortConfig();
                $rc  = $cfg['vlan'];
                if (is_array($rc['vlanId'][0])) {
                        //multiple ranges
                        $vlans = $rc['vlanId'];
                } else if (is_array($rc['vlanId'])) {
                        //only one range
                        $vlans[0]['start'] = $rc['vlanId']['start'];
                        $vlans[0]['end']   = $rc['vlanId']['end'];
                } else {
                        //only one value
                        $vlans[0]['start'] = $rc['vlanId'];
                        $vlans[0]['end'] = $rc['vlanId'];
                }
                return $vlans;
        }
}
function getNodeValue($nodeSet, $nodeName)
{
    $nodes = $nodeSet['propSet'];
    foreach ($nodes as $node) {
        if ($node['name'] == $nodeName) {
            raslogv(VCLOG_TRACE, "getNodeVal $nodeName ");
            raslogv(VCLOG_TRACE, $node['val']);
            return $node['val'];
        }
    }
    return -1;
}
?>
