<?php
include_once("VC/vCenter.php");
require_once("switch/raslog.php");
require_once("switch/logging.php");
require_once("switch/logconfig.php");

function WaitForUpdatesX($vc, $version)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        $pc   = $vc->sc->getPropertyCollector();
        $w[]  = new soapval('_this', 'PropertyCollector', $pc, false, false, $vc->attrServerGuid);
        $w['version'] = $version;
        Red($vc, "WaitForUpdates");
        $response = $conn->call('WaitForUpdates', $w, '');
        return $response;
}
function fetchPG($vc, $cr)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        $s[]  = new soapval("portgroupKey", "", "dvportgroup-74");
        $s[]  = new soapval("inside", "", "true");
        $filter[] = new soapval('_this', 'VmwareDistributedVirtualSwitch', 'dvs-72',
                                false, false, $vc->attrServerGuid);
        $filter[] = new soapval('criteria', '', $s);
        $sid = $conn->call('FetchDVPorts', $filter, $ns);

}
class Criteria {
        var $criteria;
        function Criteria($vc)
        {
                unset($s); unset($this->criteria);
                $s[]  = new soapval('portGroup', '', 'dvportgroup-74');
                $s[]  = new soapval('inside',    '', 'true');
                $ps[] = new soapval('criteria',  '', $s);
                $this->criteria = $ps;
                return $this;
        }
}
class PropertySet {
        var $propSet;
        function PropertySet($vc, $pathSets)
        {
                unset($soapmsg);
                foreach ($pathSets as $pathSet) {
                        unset($s);
                        $s['type'] = $pathSet['type'];
                        for ($i = 0 ; $i < count($pathSet) - 1; $i++) {
                            if(!empty($pathSet[$i])) 
                                $s[] = new soapval('pathSet', '', $pathSet[$i]);
                        }
                        $ps[] = new soapval('propSet', '', $s);
                }
                $this->propSet = $ps;
                return $this;
        }
}
class ObjectSet {
        var $objectSet;
        function ObjectSet($vc, $objs, $selects = 0)
        {
                unset($os); unset($o);
                foreach ($objs as $obj)
                        Red($vc, $obj['type']. "/" . $obj['value']);
                $o[] = new soapval('obj',
                                   $obj['type'],
                                   $obj['value'],
                                   false,
                                   false,
                                   $vc->attrServerGuid);
                $os[] = new soapval('objectSet', '', $o);

                $this->objectSet = $os;
                return $this;
        }
}
class Filter {
        var $filterID;
        var $faultCode;
        var $faultString;
        var $detail;
        var $error;

        function Filter($vc, $pc, $propSet, $objectSet, $partialUpdates = false)
        {
                $conn = $vc->conn;
                $ns   = $vc->ns;
                unset($filter); unset($sid); $this->error = 0;
                $spec = array_merge($propSet, $objectSet);
                $filter[] = new soapval('_this', 'PropertyCollector', $pc, false, false, $vc->attrServerGuid);
                $filter[] = new soapval('spec', '', $spec);
                if ($partialUpdates == true) {
                        $filter[] = new soapval('partialUpdates', '', 'true');
                } else {
                        $filter[] = new soapval('partialUpdates', '', 'false');
                }
                Red($vc, "CreateFilter: " . $objectSet->obj['value']);
                unset($sid);
                $sid = $conn->call('CreateFilter', $filter, $ns);
                if ($sid['faultcode'] != "s") {
                        $this->error       = -1;
                        $this->faultCode   = $sid['faultcode'];
                        $this->faultString = $sid['faultstring'];
                        $this->faultdetail = $sid['detail'];
                        return 0;
                }
                $this->filterID = $sid;
                return $this;
        }
        function Destroy($vc)
        {
                $conn = $vc->conn;
                $ns   = $vc->ns;
                unset($filter);
                $filter[] = new soapval('_this', 'PropertyFilter', $this->filterID);
                Red($vc, "DestroyFilter");
                $sid = $conn->call('DestroyPropertyFilter', $filter, '');
                $this->filterID = 0;
                return $this;
        }
}
function RetrieveProperties ($vc, $propSet, $objectSet)
{
        $sc   = $vc->sc;
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($filter);
        $spec = array_merge($propSet, $objectSet);
        $filter[] = new soapval('_this', 'PropertyCollector', $sc->getPropertyCollector(),
                                false, false, $vc->attrServerGuid);
        $filter[] = new soapval('specSet', '', $spec);
        Red($vc, "RetrieveProperties: " . $objectSet->obj['value']);
        $rp = $conn->call('RetrieveProperties', $filter, '');
        return $rp;

}
function WaitForUpdates($vc)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        $pc   = $vc->sc->getPropertyCollector();
        $w[]  = new soapval('_this', 'PropertyCollector', $pc, false, false, $vc->attrServerGuid);
        $version = $vc->monotonic;
        if (!isset($vc->monotonic)) {
                $version = "";
                $vc->monotonic = 1;
        } else {
                $vc->monotonic++;
        }
        $w['version'] = $version;
        Red($vc, "WaitForUpdates");
        $response = $conn->call('WaitForUpdates', $w, '');
        return $response;
}
function CancelWaitForUpdates($vc, $pc)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        $w[]  = new soapval('_this', 'PropertyCollector', $pc, false, false, $vc->attrServerGuid);
        Red($vc, "CancelWaitForUpdates");
        $response = $conn->call('CancelWaitForUpdates', $w, '');
        return $response;
}
?>
