<?php
class ServiceInstance {

        var $vc;
        var $sc;
        var $ic;

        function ServiceInstance($vc)
        {
                $this->vc = $vc;
                return $this;
        }

        function getServiceContent()
        {
                $sc = new ServiceContent($this->vc);
                $this->sc = $sc;

                // for implentation convenience ONLY
                $this->vc->serverGuid = $sc->getInstanceUuid();
                $this->vc->attrServerGuid['serverGuid'] = $this->vc->serverGuid;

                return $sc;
        }

        function getInternalContent()
        {
                $ic = new InternalContent($this->vc);
                $this->ic = $ic;
                return $ic;
        }

        function getCurrentTime()
        {
                $vc = $this->vc;
                $conn = $vc->conn;
                $ns   = $vc->ns;
                unset($soapmsg);
                $soapmsg['data'] = new soapval('_this', 'ServiceInstance', 'ServiceInstance');
                $clock = $conn->call("CurrentTime", $soapmsg, $ns);
                return $clock;
        }
        function queryServiceEndPointList()
        {
                $sd = $this->ic->getServiceDirectory();
                $vc = $this->vc;
                $conn = $vc->conn;
                $ns   = $vc->ns;
                unset($soapmsg);
                $soapmsg['data'] = new soapval('_this', 'ServiceDirectory', $sd, false, false, $vc->attrServerGuid);
                Red($vc, "QueryServiceEndpointList");
                $ret = $conn->call("QueryServiceEndpointList", $soapmsg, $ns);
                Green($vc, "QueryServiceEndpointList");
                vcDebug($vc, $ret);
                return $ret;
        }
}

class ServiceContent {
        var $sc;

        function ServiceContent ($vc)
        {
                $conn = $vc->conn;
                $ns   = $vc->ns;
                unset($soapmsg);
                $soapmsg['data'] = new soapval('_this', 'ServiceInstance', 'ServiceInstance');
                vcDebug($vc, $soapmsg);
                $result = $conn->call("RetrieveServiceContent", $soapmsg, $ns);
                $this->sc = $result;
                $this->vc->serverGuid = $result['about']['instanceUuid'];
                // for implentation convenience
                $this->vc->attrServerGuid['serverGuid'] = $this->vc->serverGuid;
                $vc->sc = $this;
                vcDebug($vc, $result);
                return $result;
        }
        function getAbout()
        {
                return $this->sc['about'];
        }
        function getRootFolder()
        {
                return $this->sc['rootFolder'];
        }
        function getPropertyCollector()
        {
                return $this->sc['propertyCollector'];
        }
        function getViewManager()
        {
                return $this->sc['viewManager'];
        }
        function getInstanceUuid()
        {
                return $this->sc['about']['instanceUuid'];
        }
        function getSetting()
        {
                return $this->sc['setting'];
        }
        function getuserDirectory()
        {
                return $this->sc['userDirectory'];
        }
        function getsessionManager()
        {
                return $this->sc['sessionManager'];
        }
        function getauthorizationManager()
        {
                return $this->sc['authorizationManager'];
        }
        function getperfManager()
        {
                return $this->sc['perfManager'];
        }
        function getscheduledTaskManager()
        {
                return $this->sc['scheduledTaskManager'];
        }
        function getalarmManager()
        {
                return $this->sc['alarmManager'];
        }
        function geteventManager()
        {
                return $this->sc['eventManager'];
        }
        function gettaskManager()
        {
                return $this->sc['taskManager'];
        }
        function getextensionManager()
        {
                return $this->sc['extensionManager'];
        }
        function getcustomizationSpecManager()
        {
                return $this->sc['customizationSpecManager'];
        }
        function getcustomFieldsManager()
        {
                return $this->sc['customFieldsManager'];
        }
        function getdiagnosticManager()
        {
                return $this->sc['diagnosticManager'];
        }
        function getLicenseManager()
        {
                return $this->sc['licenseManager'];
        }
        function getSearchIndex()
        {
                return $this->sc['searchIndex'];
        }
        function getFileManager()
        {
                return $this->sc['fileManager'];
        }
        function getvirtualDiskManager()
        {
                return $this->sc['virtualDiskManager'];
        }
        function getsnmpSystem()
        {
                return $this->sc['snmpSystem'];
        }
        function getvmProvisioningChecker()
        {
                return $this->sc['vmProvisioningChecker'];
        }
        function getvmCompatibilityChecker()
        {
                return $this->sc['vmCompatibilityChecker'];
        }
        function getovfManager()
        {
                return $this->sc['ovfManager'];
        }
        function getipPoolManager()
        {
                return $this->sc['ipPoolManager'];
        }
        function getdvSwitchManager()
        {
                return $this->sc['dvSwitchManager'];
        }
        function gethostProfileManager()
        {
                return $this->sc['hostProfileManager'];
        }
        function getclusterProfileManager()
        {
                return $this->sc['clusterProfileManager'];
        }
        function getcomplianceManager()
        {
                return $this->sc['complianceManager'];
        }
        function getlocalizationManager()
        {
                return $this->sc['localizationManager'];
        }
}

class InternalContent {
        var $ic;
        function InternalContent ($vc)
        {
                $conn = $vc->conn;
                $ns   = $vc->ns;
                unset($soapmsg);
                $soapmsg['data'] = new soapval('_this', 'ServiceInstance', 'ServiceInstance');
                $ic = $conn->call("RetrieveInternalContent", $soapmsg, $ns);
                $vc->ic = $ic;
                $this->ic = $ic;
                return $ic;
        }
        function getDiskManager()
        {
                return $this->ic['diskManager'];
        }
        function getNfcService()
        {
                return $this->ic['nfcService'];
        }
        function getProxyService()
        {
                return $this->ic['proxyService'];
        }
        function getServiceManager()
        {
                return $this->ic['serviceManager'];
        }
        function getServiceDirectory()
        {
                return $this->ic['serviceDirectory'];
        }
        function getResourcePlanningManager()
        {
                return $this->ic['resourcePlanningManager'];
        }
}

?>
