<?php

class MyPDO extends PDO {
        private $queryString;

        public function query(/* ... */) {
                $args = func_get_args();
                $this->queryString = func_get_arg(0);
                //echo "Q=" . $this->queryString;

                return call_user_func_array(array(&$this, 'parent::query'), $args);
        }

        public function rowCount() {
                $regex = '/^SELECT\s+(?:ALL\s+|DISTINCT\s+)?(?:.*?)\s+FROM\s+(.*)$/i';
                if (preg_match($regex, $this->queryString, $output) > 0) {
                        $stmt = parent::query("SELECT COUNT(*) FROM {$output[1]}", PDO::FETCH_NUM);

                        return $stmt->fetchColumn();
                }

                return false;
        }
}

class DB {
        var $db;
        var $conn;
        var $username;
        var $password;

        function DB($db)
        {
              $conn = new MyPDO($db);
              $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
              //$conn->setAttribute(PDO::SQLSRV_ATTR_QUERY_TIMEOUT, 1);
              $this->conn = $conn;
              $this->db  = $db;
              return $this;
        }
        function createRelation($relation, $unique="unique")
        {
                $ids  = split("-", $relation);
                $u = "";
                if ($unique === "unique") $u = ", UNIQUE($ids[0])";
                $ret = $this->conn->beginTransaction();
                $q = "CREATE TABLE IF NOT EXISTS `$relation` ( ";
                $q .= "`$ids[0]` char(10)";
                for ($i = 1; $i < count($ids); $i++) {
                        $q .= ", `$ids[$i]` char(10)";
                }
                $q .= "$u )";
                //echo "RELAT: $q \n";
                $ret = $this->conn->exec($q);
                $ret = $this->conn->commit();
        }
        function addRelations($relation, $ts, $f)
        {
                $ids  = split("-", $relation);
                $to   = $ids[0];
                $from = $ids[1];
                $ret  = $this->conn->beginTransaction();
                foreach ($ts as $t) {
                        $q = "INSERT INTO `$relation` ($from, $to) VALUES ('$f', '$t')";
                        //echo "$q \n";
                        try {
                                $ret = $this->conn->exec($q);
                        } catch (Exception $e) {}
                }
                $ret = $this->conn->commit();
        }
        function addRelation($relation, $f)
        {
                $ids  = split("-", $relation);
                $ret = $this->conn->beginTransaction();
                $q = "INSERT INTO `$relation` (";
                $q .= "$ids[0]";
                for ($i = 1; $i < count($ids); $i++) {
                        $q .= ", $ids[$i]";
                }
                $q .= ") VALUES (";

                $q .= "'$f[0]'";
                for ($i = 1; $i < count($ids); $i++) {
                        $q .= ", '$f[$i]'";
                }
                $q .= ")";
                //echo "$q \n";
                try {
                        $ret = $this->conn->exec($q);
                } catch (Exception $e) {}
                $ret = $this->conn->commit();
        }
        function getRelations($relation, $f)
        {
                $ids  = split("-", $relation);
                $to   = $ids[0];
                $from = $ids[1];
                $q = "SELECT $to FROM `$relation` WHERE $from='$f'";
                $pstmt= $this->conn->query($q);
                $rows = $pstmt->fetchAll(PDO::FETCH_COLUMN, 0);
                return $rows;
        }
        function addObj($id, $name, $uuid = "")
        {
                $debug = 0;
                $ids   = split("-", $id);
                $table = $ids[0]    . "s";
                $uid   = $ids[1];

                $name  = sqlite_escape_string($name);
                $q     = "SELECT * FROM $table WHERE id='$id' AND name='$name'";
                $msg   = "Add $ids[0] = $name id= $id";

                $stmt  = $this->conn->query($q);
                $n     = $this->conn->rowCount();
                if     ($n != 0) {
                    if ($debug != 0) {
                        raslogv(RASLOG_INFO, $msg . " (already)");
                    }
                    return 1;
                }
                $ret = $this->conn->beginTransaction();
                $q   = "INSERT INTO $table (id, name) values ('$id', '$name')";
                $ret = $this->conn->exec($q);
                $ret = $this->conn->commit();
                if ($debug != 0) {
                    raslogv(RASLOG_INFO, $msg . " (success)");
                }
                return 1;
        }
        function getObj($id, $name, $uuid = "")
        {
                $ids   = split("-", $id);
                $table = $ids[0]    . "s";
                $uid   = $ids[1];

                $name  = sqlite_escape_string($name);
                $q     = "SELECT * FROM $table WHERE id='$id' AND name='$name'";

                $stmt  = $this->conn->query($q);
                $n     = $this->conn->rowCount();
                if     ($n != 0) {
                        echo "Already have $ids[0] = $name id = $id\n";
                        return -1;
                }
                $row = $pstmt->fetchAll(PDO::FETCH_BOTH);
        }
        function runSQL($sql)
        {
                echo $sql;

                $stmt  = $this->conn->query($sql);
                $n     = $this->conn->rowCount();
                //echo "COUNT=$n \n";
                $rows = $stmt->fetchAll(PDO::FETCH_BOTH);
                return $rows;
        }
        function getTableObjs($table, $sql)
        {
                $q     = "SELECT * FROM '$table' WHERE $sql";
               // echo $q;

                $stmt  = $this->conn->query($q);
                $n     = $this->conn->rowCount();
                //echo "COUNT=$n \n";
                $rows = $stmt->fetchAll(PDO::FETCH_BOTH);
                return $rows;
        }
        function isFresh($id, $timeout)
        {
        }
        function refreshAttr($id)
        {
                $ids   = split("-", $id);
                $table = $ids[0]    . "s";
                $uid   = $ids[1];

                $ts = time(0);
                $q     = "UPDATE $table SET ";
                $q .= "createTS='$ts',valid='1'";
                $q .= " WHERE id='$id'";

                $ret = $this->conn->beginTransaction();
                $ret = $this->conn->exec($q);
                $ret = $this->conn->commit();
                return $ret;
        }
        function updateAttr($table, $whereclause, $attr, $val)
        {
                $q     = "UPDATE $table SET ";
                if (count($attr) == 0) return 0;
                for ($i = 0; $i < count($attr); $i++) {
                        if ($i != 0) $q .= ",";
                        $val[$i] = sqlite_escape_string($val[$i]);
                        $q .= "$attr[$i]='$val[$i]'";
                }
                $q .= " WHERE ".$whereclause;
                //echo "$q \n";

                $ret = $this->conn->beginTransaction();
                $ret = $this->conn->exec($q);
                $ret = $this->conn->commit();
                return $ret;
        }

        function setAttr($id, $attr, $val)
        {
                $ids   = split("-", $id);
                $table = $ids[0]    . "s";
                $uid   = $ids[1];

                $q     = "UPDATE $table SET ";
                if (count($attr) == 0) return 0;
                for ($i = 0; $i < count($attr); $i++) {
                        if ($i != 0) $q .= ",";
                        $val[$i] = sqlite_escape_string($val[$i]);
                        $q .= "$attr[$i]='$val[$i]'";
                }
                $q .= " WHERE id='$id'";
                //echo "$q \n";

                $ret = $this->conn->beginTransaction();
                $ret = $this->conn->exec($q);
                $ret = $this->conn->commit();
                return $ret;
        }

        function deleteObj($id)
        {
                $ids   = split("-", $id);
                $table = $ids[0]    . "s";
                $uid   = $ids[1];

                $ret = $this->conn->beginTransaction();
                $q = "DELETE FROM $table WHERE id='$uid'";
                $ret = $this->conn->exec($q);
                $err = $this->conn->errorCode();
                if ($err != "00000") {
                        echo $err;
                        return -1;
                }
                $ret = $this->conn->commit();
                return 1;
        }
        function listObjs($id)
        {
                $ids   = split("-", $id);
                $table = $ids[0]    . "s";
                $uid   = $ids[1];

                unset($list);
                $q = "SELECT * FROM $table WHERE idc='$uid'";
                foreach ($this->conn->query($q) as $row)
                        $hs[] = $row;
                return $hs;
        }
}


?>
