<?php
require_once("nusoap/nusoap.php");

class vCenter {

        var $vCenter = "vCENTER";
        var $version;

        var $url;
        var $user;
        var $pass;

        var $conn;
        var $ns;
        var $debug;

        var $si;
        var $sc;
        var $ic;

        var $monotonic;
        var $is_vCenter;
        var $serverGuid;
        var $attrServerGuid;

        function vCenter($url, $ns, $user, $pass)
        {
                if (empty($url) || empty($user) || empty($pass))
                        return -1;
                $this->url        = $url;
                $this->ns         = $ns;
                $this->user       = $user;
                $this->pass       = $pass;
                $this->monotonic  = "";
                $this->is_vCenter = true;
                return $this;
        }

        function initServices()
        {
                $si = new ServiceInstance($this);
                $this->si = $si;

                $sc = $si->getServiceContent();
                $this->sc = $sc;

                $instance = $sc->getInstanceUuid();
                if (empty($instance)) return -1;

                $ic = $si->getInternalContent();
                $this->ic = $ic;

                return 1;
        }

        function vConnect()
        {
                $sdk = $this->url . "/sdk";
// 360 sec timeout
//                $this->conn = new nusoapclient($sdk,false,false,false, false, false, $timeout,  $timeout);

                $this->conn = new nusoapclient($sdk);
                return $this->conn;
        }

        function login()
        {
                if (!isset($this->sc))
                        die("Must initiaize Service Content");
                $sc   = $this->sc;
                $conn = $this->conn;
                $ns   = $this->ns;
                $user = $this->user;
                $pass = $this->pass;
                
                if (($sm = new SessionManager($sc, $conn, $ns)) != -1) {
                        $lo = $sm->Login($user, $pass, "");
                        if (!is_array($lo))
                                return -1;
                        if ($lo['faultcode'] == "ServerFaultCode") {
                                return -1;
                        }
                        return 1;
                }
                return -1;
        }
        function getVersion()
        {
                $sc   = $this->sc;
                $about = $sc->getAbout();
                $version = $about['version'];
                return $version;
        }
        function setDebug($flags)
        {
                $this->debug = $flags;
        }
        function getDebug()
        {
                return $this->debug;
        }
}

class SessionManager {

        var $conn;
        var $ns;
        var $sm;

        var $message;
        var $currentSession;
        var $defaultLocale;
        var $sessionList;
        var $supportedLocaleList;

        function SessionManager($sc, $conn, $ns)
        {
                $this->conn = $conn;
                $this->ns   = $ns;
                $this->sm   = $sc->getSessionManager();
        }
        function Login($user, $pass, $locale)
        {
                $conn = $this->conn;
                $ns   = $this->ns;
                unset($soapdata);
                $soapmsg['data']     = new soapval('_this', 'SessionManager', $this->sm);
                $soapmsg['userName'] = $user;
                $soapmsg['password'] = $pass;
                $result = $conn->call("Login", $soapmsg, $ns);
                return $result;
        }
        function Logout()
        {
                $conn = $this->conn;
                $ns   = $this->ns;
                unset($soapdata);
                $soapmsg['data'] = new soapval('_this', 'SessionManager', 'SessionManager');
                $result = $conn->call("Logout", $soapmsg, $ns);
                return $result;
        }
        function UpdateServiceMessage($msg)
        {
                // not tested
                $this->message = $msg;
                $conn = $this->conn;
                $ns   = $this->ns;
                unset($soapdata);
                $soapmsg['data'] = new soapval('_this', 'SessionManager', 'SessionManager');
                $result = $conn->call("Logout", $soapmsg, $ns);
                return $result;
        }
        function QueryConnectInfo($vc, $hostname, $username, $password, $sslthumb = "")
        {
                $conn = $vc->conn;
                $ns   = $vc->ns;
                $soapmsg[] = new soapval('_this',    'Datacenter', 'datacenter-160', false, false, $vc->attrServerGuid);
                $soapmsg[] = new soapval('hostname', '',           $hostname);
                $soapmsg[] = new soapval('port',     '',           -1);
                $soapmsg[] = new soapval('username', '',           $username);
                $soapmsg[] = new soapval('password', '',           $password);
                $soapmsg[] = new soapval('sslThumbprint', '',      $sslthumb);
                $result = $conn->call("QueryConnectInfo", $soapmsg, $ns);
        }
}
class vMachine {
        var $capabilities;
        var $info;
};


