<?php

require_once("switch/raslog.php");
require_once("switch/switchport.php");
require_once("VC/sql.php");
require_once("switch/logconfig.php");
require_once("switch/logging.php");

$db = "sqlite:/tmp/dc.db";

define("SUCCESS",   0);
define("FAIL",      -1);
$dbh = new DB($db);
$ifname           = $_SERVER[argv][1];
$version          = $_SERVER[argv][2];
$host_name        = $_SERVER[argv][3]; // host_nn
$vmnic_name       = $_SERVER[argv][4]; // vmnic name
$software_version = $_SERVER[argv][5];
$platform         = $_SERVER[argv][6];
$connected        = $_SERVER[argv][7]; // is connected

$log = Logging::getInstance(); 

   raslogv(RASLOG_INFO, "$ifname $version $host_name $vmnic_name $software_version $platform enable(1)/disable(0) :$connected");

$sp = new switchport($ifname);
$chgrp = $sp->channel_group();
if ($chgrp == -1) {
   if($connected != 1) {
       raslogv(VCLOG_INFO, "PORT disableProfileMode");
       if ( $sp->disableProfileMode() != FAIL) {
            // success
            $sp->shutdown(0); // no shut
            $log->lclose();
            exit(SUCCESS);
        }else {
            $log->lclose();
            exit(FAIL);
        }
       
   } else  {
       raslogv(VCLOG_INFO, "PORT enableProfileMode");
       if ( $sp->enableProfileMode() != FAIL) {
            $log->lclose();
            exit(SUCCESS);
        }else {
            $log->lclose();
            exit(FAIL);
        }
   }
} else {
   if($connected != 1) {
        // check if the port channel has other active members in cdp
        // if yes, we don't disable profile mode
        $q = "SELECT iface FROM vmnics WHERE iface IS NOT NULL AND iface != '' AND iface != '$ifname'";
        $stmt = $dbh->conn->prepare($q); 
        $stmt->execute();
        while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
            $iface = $row['iface'];
            $sp1 = new switchport($iface);
            $chgrp1 = $sp1->channel_group();
            raslogv(VCLOG_TRACE, "$iface in port channel $chgrp1");
            if ($chgrp == $chgrp1) {
                raslogv(VCLOG_INFO, "Skipping PORTCHANNEL disableProfileMode");
                exit(SUCCESS);
            }
        }
       raslogv(VCLOG_INFO, "PORTCHANNEL disableProfileMode");
        // port channel
        $pc = new portchannel($chgrp);
       if ( $pc->disableProfileMode() != FAIL) {
            // success
            $pc->shutdown(0); // no shut
            $log->lclose();
            exit(SUCCESS);
        }else {
            $log->lclose();
            exit(FAIL);
        }
   } else  {
       raslogv(VCLOG_INFO, "PORTCHANNEL enableProfileMode");
        $pc = new portchannel($chgrp);
       if ( $pc->enableProfileMode() != FAIL) {
            $log->lclose();
            exit(SUCCESS);
        }else {
            $log->lclose();
            exit(FAIL);
        }
    }
}

    $log->lclose();
    exit(FAIL);
?>
