<?php

require_once("VC/sql.php");
require_once("switch/logconfig.php");
define("DELETE",1);
define("ADD",   2);
define("UPDATE",3);

/* $pp is the object to apply the operations of add/delete/updates */
function diffTable($table, $dbnew, $dbold, $pp, $del)
{

        $dbx1 = $dbnew;
        $dbx2 = $dbold;

        raslogv(VCLOG_INFO, "deltaTable for Deletes $table");
        deltaTable($table, $dbx2, $dbx1, $pp, DELETE); // deletes

        if ($del != "true") {
        raslogv(VCLOG_INFO, "deltaTable for Add $table");
        deltaTable($table, $dbx1, $dbx2, $pp, ADD); // adds
        }

        if ($del != "true") {
        raslogv(VCLOG_INFO, "deltaTable for Update $table");
        deltaTable($table, $dbx1, $dbx2, $pp, UPDATE); // changes
}
}

/*
Compare $table from two databases db1(new) and db2(old) $direction can be ADD|DELETE|UPDATE
1. get all rows of $table. for eg assume $table is portgroups 
2. for each new portgroup p1, check if it exists in old p2.
3. if the p2 is same do nothing.
4. if p2 does not exist $add =1
5. if direction is ADD if p2 is missing
    than 
      create the port profile
5. if direction is DELETE if p2 is missing
    than 
      delete the port profile
5. if direction is UPDATE 
    than 
      deactivatePortProfile();
      remove_Vlan_for_PP($pp, $row2['vlan']);
      add_Vlan_for_PP($pp, $row1['vlan']);
      activatePortProfile();
Compare VMS $table from two databases db1(new) and db2(old) $direction can be ADD|DELETE|UPDATE
1. get all rows of $table. for eg assume $table is vms 
2. for each new vm v1, check if it exists in old v2.
3. if the v2 is same do nothing.
4. if v2 does not exist $add =1
5. if direction is ADD if v2 is missing 
    than 
      get the pg name from vm.getdvpgid in new portgroups table
      deactivatePortProfile();
      addStaticMac(formatMac6_2_Mac3($mac));
      activatePortProfile();
       
5. if direction is DELETE if v2 is missing 
    than 
      get the pg name from vm.getdvpgid in new  portgroups table
      deactivatePortProfile();
      delStaticMac(formatMac6_2_Mac3($mac));
      activatePortProfile();
5. if direction is UPDATE 
    than 
      get the new pg name from vm.getdvpgid in new  portgroups table
      get the old pg name from vm.getdvpgid in new  portgroups table
      
      if old_pg is empty      
        $pp->deactivatePortProfile();
        $pp->delStaticMac(formatMac6_2_Mac3($mac));
      if old_pg is not empty      
        $oldpp->deactivatePortProfile();
        $oldpp->delStaticMac(formatMac6_2_Mac3($mac));

      if new_pg is not empty      
        $newpp->deactivatePortProfile();
        $newpp->addStaticMac(formatMac6_2_Mac3($mac));
        activatePortProfile();

*/

function deltaTable($table, $db1, $db2, $pp, $direction)
{
        $dbh1 = new DB($db1);
        $dbh2 = new DB($db2);

        $q1      = "SELECT * FROM $table";
        $stmt = $dbh1->conn->prepare($q1);
        $stmt->execute();

        if ($table == "dvportgroups" || $table == "portgroups") {
            $pp_sock = maapi_connect1();
        } else if ($table == "vnics" && $direction == UPDATE) {
            // open only one socket for all mac associations
            $ns = appm__ns;
            $sock = maapi_connect($ns);
        } else {
            // this is for mac deletions
            $mac_sock = maapi_connect1();
        }
        $pp_list = array(); // created pps

        while ($row1 = $stmt->fetch(PDO::FETCH_ASSOC)) {

                $add = 0;
                $id1 = $row1['id'];

                $q2 = "SELECT * FROM $table WHERE id = '$id1'";
                $pstmt2 = $dbh2->conn->query($q2);
                $row2 = $pstmt2->fetch(PDO::FETCH_ASSOC);

                if (!is_array($row2)) {
                        $row2 = array();
                        $add = 1;
                } else if ($table == "dvportgroups") {
                    // incase of dvportgroups we need to delete and create on a dvportgroup rename
                    $pg_nn1 = $row1['name'];
                    $pg_nn2 = $row2['name'];
                    if ($pg_nn1 != $pg_nn2)
                        $add = 1;
                } else if ($table == "vnics" && $direction == DELETE) {
                    // if mac is assigned to a new pg, remove it from the old pg in DELETE
                    $pg1_nn     = $row1['dvpg_nn'];
                    $pg2_nn     = $row2['dvpg_nn'];
                    $add = ($pg1_nn != $pg2_nn) ? 1 : 0;
                }

                $result = array_diff_assoc($row1, $row2);
                if (count($result) == 0) {
                //    $nn1 = $row1['name'];
               //     $nn2 = $row2['name'];
                //    raslogv(RASLOG_INFO, "$nn1 SAME $nn2 $add $direction ");
                     continue;
                }
                
                if ($add == 1 && $direction == ADD) {
                        if ($table == "dvportgroups" || $table == "portgroups") {
                                $mor = $row1['id'];
                                $pg_nn = trimSpaces($row1['name']);
                                //$pg_nn = $row1['name'];
                                $isUplink = $row1['pgtype'];
                                if ($isUplink == "uplink") {
                                        raslogv(VCLOG_DEBUG, "Skipping the upg $pg_nn");
                                        continue;
                                }else
                                        raslogv(VCLOG_DEBUG, "Processing the pg $pg_nn");
                                $pp_nn = "auto-" . $pg_nn;

                                if (array_key_exists($pp_nn,$pp_list)) {
                                        raslogv(VCLOG_INFO, "Already processed $pp_nn");
                                        continue;
                                }else {
                                        raslogv(VCLOG_INFO, " Processing $pp_nn");
                                        $pp_list[$pp_nn] = 1;
                                }

                                $pp = new portprofile($pp_nn);
                                $pp->create($pp_sock);
                                add_Vlan_for_PP($pp_sock, $pp, $row1['vlan']);
                                $pp->activatePortProfile($pp_sock);
                                unset($pp);
                                continue;
                        }
                }
                if ($add == 1 && $direction == DELETE) {
                        if ($table == "dvportgroups" || $table == "portgroups") {
                                $pg_nn = $row1['name'];
                                $dvpg    = getPgByName($dbh2, $pg_nn);
                                // shouldn't this check only apply for portgroups and not dvpgs??
                                // for dvpgs, if we change dvpg1 to dvpg2 and dvpg3 to dvpg1, we should
                                // delete dvpg1 and recreate it again with the new vlan info
                                // however for pgs, b/c we replicate the pgs on different hosts for 
                                // vmotion purposes, we shouldn't delete the profile
                                if ($table != "dvportgroups" && !empty($dvpg)) {
                                    raslogv(VCLOG_DEBUG, "Skipping the port group delete since it is in use $pg_nn");
                                    continue;
                                }
                                
                                $pg_nn = trimSpaces($row1['name']);
                                $pp = new portprofile("auto-" . $pg_nn);
                                $pp->delete($pp_sock);
                                unset($pp);
                    
                                continue;
                        }
                        if ($table == "vnics") { 
                                $mor       = $row1['id'];
                                $vm_nn     = $row1['name'];
                                $mac       = $row1['mac'];
                                $dvpg_id   = $row1['dvpg_id'];

                                if (empty($dvpg_id)) continue;

                                $dvpg    = getPgById($dbh1, $dvpg_id);
                                $isUplink = $dvpg[0]['pgtype'];
                                if ($isUplink == "uplink") {
                                        raslogv(VCLOG_DEBUG, "Skipping the upg $pg_nn");
                                        continue;
                                }
                                $dvpg_nn = trimSpaces($dvpg[0]['name']);
                                $pp      = new portprofile("auto-" . $dvpg_nn);
                                $rc = $pp->delStaticMac($mac_sock, formatMac6_2_Mac3($mac));
                                if ($rc == -1) {
                                    raslogv(RASLOG_INFO, "Failed Deleting MAC $mac from port profile $pp_name");
                                    unset($attr); unset($val);
                                    $attr[] = "valid"; $val[] = -1;
                                    $dbh1->setAttr($mor, $attr, $val);
                                    continue;
                                }
                         

                                unset($attr); unset($val);
                                $attr[] = "port_prof"; $val[] = "";
                                $attr[] = "valid"; $val[] = 1;
                                $dbh1->setAttr($mor, $attr, $val);
                                continue;
                        }
                }
                if ($direction == UPDATE) {
                        if (($table == "dvportgroups" || $table == "portgroups") && $add != 1) {
                                $mor = $row1['id'];
                                //$pg_nn = $row1['name'];
                                $pg_nn = trimSpaces($row1['name']);
                                $isUplink = $row1['pgtype'];
                                if ($isUplink == "uplink") {
                                        $vlans = $row1['vlan'];
                                        raslogv(VCLOG_DEBUG, "Skipping the upg $pg_nn & vlans $vlans ");
                                        continue;
                                }
                                $v2 = $row2['vlan'];
                                $v1 = $row1['vlan'];
                                $name2 = $row2['name'];
                                $name1 = $row1['name']; 
                                if (($name1 == $name2) && ($v1 == $v2)) {
                                    // we hit this case when for a dvpg, name and vlan are the same but 
                                    // dvs name has changed. therefore we don't want to reconfigure the
                                    // mac again
                                    raslogv(VCLOG_DEBUG, "Update called for dvpg $pg_nn with no changes, skipping processing it");
                                    continue;
                                }

                                $pp_nn = "auto-" . $pg_nn;

                                if (array_key_exists($pp_nn,$pp_list)) {
                                        raslogv(VCLOG_DEBUG, "Already processed $pp_nn");
                                        continue;
                                }else {
                                        raslogv(VCLOG_DEBUG, " Processing $pp_nn");
                                        $pp_list[$pp_nn] = 1;
                                }
                                $pp = new portprofile($pp_nn);
                                $pp->deactivatePortProfile($pp_sock);
                                {
                                        remove_Vlan_for_PP($pp_sock, $pp, $row2['vlan']);
                                        add_Vlan_for_PP($pp_sock, $pp, $row1['vlan']);
                                }
                                $pp->activatePortProfile($pp_sock);
                                unset($pp);
                                continue;
                        }
                        if ($table == "vnics") {
                                $mor = $row1['id'];
                                $vm_nn     = $row1['name'];
                                $mac       = $row1['mac'];
                                $dvpg_id_new   = $row1['dvpg_id'];

                                $pg1_nn     = $row1['dvpg_nn'];
                                $valid     = $row2['valid'];
                                $pg2_nn     = $row2['dvpg_nn'];
                                $isSame = ($pg1_nn == $pg2_nn) ? 1 : 0;
                                /*Addresses both a association failure case and a mac move to a new PG case */
                                if (($valid == 1) && $isSame) {
                                    // we hit here on every row 
                                    // casue in array_diff port-profile column is different
                                    // so here either there are no changes at all or a vmotion
                                    raslogv(VCLOG_DEBUG, "No more processing needed $pg1_nn $pg2_nn $mac");
                                    continue;
                                }else {
                                    raslogv(VCLOG_INFO, "Processing needed $pg1_nn $pg2_nn $mac");
                                }

                                // why do we need this? aren't these the same as pg1_nn and pg2_nn?
                                $dvpg_new    = getPgById($dbh1, $dvpg_id_new);
                                $dvpg_nn_new = trimSpaces($dvpg_new[0]['name']);

                                $dvpg_id_old = $row2['dvpg_id'];

                                $dvpg_old    = getPgById($dbh2, $dvpg_id_old);
                                $dvpg_nn_old = trimSpaces($dvpg_old[0]['name']);


                                if (!empty($dvpg_nn_old) && !$isSame ) {
                                        // mac is already removed from old pg in delete
                                        //hence commenting out this part
                                        /*$pp_name   = "auto-" . $dvpg_nn_old;
                                        raslogv(VCLOG_INFO, "Removing the mac $mac  from  $pp_name ");
                                        $pp      = new portprofile($pp_name);
                                        //$pp->deactivatePortProfile();
                                        $rc = $pp->delStaticMac(formatMac6_2_Mac3($mac));
                                        if ($rc == -1) {
                                            raslogv(RASLOG_INFO, "Failed Deleting MAC $mac from port profile $pp_name");
                                            continue;
                                        }
                                        //$pp->activatePortProfile();*/
                                }else
                                        raslogv(VCLOG_DEBUG, "Skipping delStatic $mac $isSame $dvpg_nn_old");

 
                                if (!empty($dvpg_nn_new)) {
                                        $pp_name   = "auto-" . $dvpg_nn_new;
                                        raslogv(VCLOG_INFO, "Adding the mac $mac to $pp_name ");
                                        $pp      = new portprofile($pp_name);
                                        //$pp->activatePortProfile();
                                        $rc = $pp->addStaticMac($sock, formatMac6_2_Mac3($mac));
                                        if ($rc == -1) {
                                            raslogv(RASLOG_INFO, "Failed Adding MAC $mac to port profile $pp_name");
                                        unset($attr); unset($val);
                                        $attr[] = "valid"; $val[] = -1;
                                        $dbh1->setAttr($mor, $attr, $val);
                                            continue;
                                        }

                                        unset($attr); unset($val);
                                        $attr[] = "port_prof"; $val[] = $pp_name;
                                        $attr[] = "valid"; $val[] = 1;
                                        $dbh1->setAttr($mor, $attr, $val);
                                        continue;

                                }else
                                        raslogv(VCLOG_DEBUG, "Skipping addStatic $mac");
                        }
                }
        }
        if ($table == "dvportgroups" || $table == "portgroups") {
            maapi_close($pp_sock);
        } else if ($table == "vnics" && $direction == UPDATE) {
            // one maapi_apply and maapi_close for mac associations
            $rc = maapi_apply($sock);
            maapi_close($sock);
        } else {
            maapi_close($mac_sock);
        }
}

/*
Conversion of vCenter configuration to Brocade switch configuration:
--------------------------------------------------------------------
vlan (none) i.e EST (External switch tagging)  --> switchport access vlan 1
vlan All(4095) i.e VGT (Virtual Guest Tagging)  --> switchport trunk allowed vlan all + switchport trunk native-vlan 1
vlan (range a-b) i.e VGT (Virtual Guest Tagging) --> switchport trunk allowed vlan add a-b
vlan (range 0-b) i.e VGT (Virtual Guest Tagging) --> switchport trunk allowed vlan add 2-b + switchport trunk native-vlan 1
vlan (x) i.e VGT (Virtual Switch Tagging) --> switchport trunk allowed vlan x
*/

function add_Vlan_for_PP($sock, $pp, $vlan_ranges)
{
        static $ifvlan;
        unset($vlan);
        /*vlan_ranges is one or multiple ranges separated by comma
         * e.g. (0-0,)     (1-1,)    (4095-4095,)    (0-0,1-5,2-2,) (0-5,7,12-19)
         */
        $pos = strpos($vlan_ranges, ",");
        $vlan_range = strtok($vlan_ranges, ",");
        $vlan = split("-", $vlan_range);
        $vlan_start = $vlan[0];
        $vlan_end   = $vlan[1];
        // vlan (none)
        if (($pos === (strlen($vlan_ranges)-1)) && ($vlan_start == 0) && ($vlan_end == 0)) {
            // vlan_ranges is 0-0,   
            raslogv(VCLOG_DEBUG, "vlan_range is 0-0 $pp->name"); 
            //echo "vlan_range is 0-0\n"; 
            $ret = $pp->setVlanProfile($sock, "switchport", "access", "1", "1");
        } else {
            while ($vlan_range !== false) {
                //echo "$vlan\n";
                $vlan = split("-", $vlan_range);
            
                $vlan_start = $vlan[0];
                $vlan_end   = $vlan[1];
                raslogv(VCLOG_DEBUG, "vlan_range is $vlan_start - $vlan_end $pp->name");
                //echo "$vlan_start\t$vlan_end\n";

                // CAUTION: Should we create the interface vlans?

                if (!isset($ifvlan)) $ifvlan = new interfaceVlan();
                $ret = $ifvlan->createInterfaceVlan($sock, $vlan_start, $vlan_end);

                $ret = $pp->setVlanProfile($sock, "switchport", "trunk", $vlan_start, $vlan_end);
                $vlan_range = strtok(",");
            }
        }
}

function remove_Vlan_for_PP($sock, $pp)
{
        $vlan_start = -1;
        $vlan_end   = -1;

        $ret = $pp->setVlanProfile($sock, "switchport", "trunk", $vlan_start, $vlan_end);
}

?>
