<?php

require_once("nusoap/nusoap.php");
require_once("config/config.php");
require_once("config/eventlist.php");
require_once("VC/vCenter.php");
require_once("VC/vAPI.php");
require_once("VC/pc.php");
require_once("VC/si.php");
require_once("VC/sql.php");
require_once("VC/utils.php");
require_once("VC/dvswitch.php");
require_once("switch/portprofile.php");
require_once("switch/interface.php");
require_once("switch/logging.php");
require_once("switch/logconfig.php");
require_once("switch/raslog.php");



$vcenter        = $_SERVER[argv][1];
$url            = $_SERVER[argv][2];
$user           = $_SERVER[argv][3];
$pass           = $_SERVER[argv][4];
$serverport     = $_SERVER[argv][5];
/*
//$timeout        = 360000;//100 hrs
*/
// for testing 
//$vcenter        = "sada";
/*
//$url            = "http://10.20.49.131";
$url            = "http://10.24.84.150";
$user           = "administrator";
$pass           = "pass";
//$timeout        = "360000"; // seconds
$activate       = "discover";
*/

$log = Logging::getInstance(); 
raslogv(RASLOG_INFO, "START: event monitoring for vCenter @ $url");

if ($activate !== "discover") {
	raslogv(RASLOG_WARNING, "discovery not allowed yet DISCOVER_NOTSET");
	$log->lclose();
	exit(DISCOVER_NOTSET);
}

if (($vc  = new vCenter($url, $ns, $user, $pass)) < 0) {
}

$ret = $vc->setDebug(0);
//$ret = $vc->setDebug($debug);

if (($ret = $vc->vConnect()) < 0) {
//if (($ret = $vc->vConnect($timeout)) < 0) {
	raslogv(RASLOG_WARNING, "Connect to vCenter failed (url = $url) INVALID_CONNECTION");
	$log->lclose();
	exit(INVALID_CONNECTION);
}

$ret = $vc->initServices();
if ($ret == -1) {
	raslogv(RASLOG_ERROR, "Cannot Initialize Services on vCenter");
	$log->lclose();
	exit(NO_SERVICE);
}
$version = $vc->getVersion();
raslogv(VCLOG_TRACE, "VC version $version");
if (!starts_with($version,"4") && !starts_with($version,"5")) {
	raslogv(RASLOG_ERROR, "Invalid vCenter Version ($version), (only versions 4.x and 5.x supported)");
	$log->lclose();
	exit(INVALID_VERSION);
}
if (($ret = $vc->login()) != 1) {
	raslogv(RASLOG_ERROR, "Failed communicating to vcenter $url Invalid Credentials ");
	$log->lclose();
	exit(INVALID_CREDENTIALS);
}
raslogv(VCLOG_INFO, "Login succeed for user ($url) ");
raslogv(VCLOG_INFO, "Login TIME $time seconds ");


//$sw->start();
try {

	$sc = $vc->sc;

	$view_sess = CreateCollectorForEvents($vc, 'Folder', $sc->geteventManager(), $motype,$EVENT_LIST);

	$et1[] = new soapval('type', '', 'EventHistoryCollector');
	$et1[] = new soapval('all', '', 'false');
	$et1[] = new soapval('pathSet', '', 'latestPage');
	$ps[] = new soapval('propSet', '', $et1);   
             
	$et2[] = new soapval('obj', 'EventHistoryCollector', $view_sess);
	$et2[] = new soapval('skip', '', 'false');
	$os[] = new soapval('objectSet', '', $et2);   

 
	$vmfilter = new Filter($vc, $sc->getPropertyCollector(), $ps, $os, true);
	$version="";
	while(1) {
		raslogv(VCLOG_INFO, "Waiting for updates... $version ");
		$wfu     = WaitForUpdatesX($vc, $version);
		if (empty($wfu)) {
			raslogv(VCLOG_INFO, "Waitforupdates timeout resetting the version");
			$version="";
		}else{
			raslogv(VCLOG_INFO, "EVENTS!! found....");
			if ($version=="") {
				// purge the first events
				raslogv(VCLOG_INFO, "Skipping First events ");
			}else {
				processEvents($wfu);
			}
			$version = $wfu['version'];
		}
	}
	raslogv(RASLOG_INFO, "END: Stopping the event listening @ $url");

	$log->lclose();

}catch (Exception $e) {
	raslogv(RASLOG_ERROR, "Error parsing the vcenter inventory $e->getMessage()");
	$log->lclose();
}

function processEvents($wfu)
{

	raslogv(VCLOG_INFO, "Process Events version $version");
	$version = $wfu['version'];
	$filter  = $wfu['filterSet']['filter'];
	$objset    = $wfu['filterSet']['objectSet'];
	$changeset = $objset['changeSet'];
	$mo = $changeset['val']['Event'];
	raslogv(VCLOG_TRACE, $changeset);
	if (is_array($mo)) {
		for ($i = 0 ; $i < count($mo); $i++) {
			processEvent($mo[$i]);
		}
	} else if (is_array($changeset)) {
		for ($i = 0 ; $i < count($changeset); $i++) {
			raslogv(VCLOG_TRACE, $changeset[$i]);
			$evnt = $changeset[$i]['val'];
			processEvent($evnt);
		}

	} else if (is_array($changeset)) {
		raslogv(VCLOG_TRACE, $changeset);
		processEvent($changeset);
	}
}

function processEvent($event)
{
	if (empty($event)) return;
	$key = $event['key'];
	$type= $event['type'];
	$event_type = getEventType($type);
	if ($event_type == -1) {
		raslogv(VCLOG_ERROR, "Unsupported Evnt encountered, Skipping this event");
		raslogv(VCLOG_ERROR, $event);
		return;
	}
	$chain_id = $event['chainId'];
	$host_mor = $event['host']['host'];
	$host_ip = $event['host']['name'];
	$vm_mor = $event['vm']['vm'];
	$vm_name = $event['vm']['name'];
	$dhost_mor = $event['destHost']['host'];
	$dhost_ip = $event['destHost']['name'];
	$shost_mor = $event['sourceHost']['host'];
	$shost_ip = $event['sourceHost']['name'];
	raslogv(VCLOG_INFO, "type:$type, event_type:$event_type key:$key, chain_id:$chain_id, host:$host_mor, host_ip:$host_ip, vm:$vm_mor, vm_name:$vm_name, dhost:$dhost_mor, dhost_ip:$dhost_ip, shost:$shost_mor, shost_ip:$shost_ip");

    if (empty($shost_mor)) {
        $shost_mor = $host_mor;
        $shost_ip = $host_ip;
    } else if (empty($dhost_mor)) {
        $dhost_mor = $host_mor;
        $dhost_ip = $host_ip;
    }

    global $vc;
    $vcip_comp = parse_url($vc->url);
	$vc_ip = $vcip_comp['host'];

    $shell_input = "$key $chain_id $event_type $vc_ip $shost_mor $dhost_mor $vm_mor ";
    
    $vm = new vm($vc, $vm_mor);
    $vm->retrieveProperties();

    $src_host = new host($vc, $shost_mor);
    $src_host->retrieveProperties();

    $dest_host = new host($vc, $dhost_mor);
    $dest_host->retrieveProperties();
    $sc_ip ="0.0.0.0";
    $service_consoles = $src_host->getConsoleVnic();
    foreach ($service_consoles as $sc) {
        if (empty($sc)) continue;
        $sc_mac = $sc['spec']['mac'];
        $sc_ip = $sc['spec']['ip']['ipAddress'];
        $sc_subnet = $sc['spec']['ip']['subnetMask'];
    }

    $shell_input .= "$sc_ip ";

    unset($service_consoles);

    $service_consoles = $dest_host->getConsoleVnic();
    foreach ($service_consoles as $sc) {
        if (empty($sc)) continue;
        $sc_mac = $sc['spec']['mac'];
        $sc_ip = $sc['spec']['ip']['ipAddress'];
        $sc_subnet = $sc['spec']['ip']['subnetMask'];
    }

    $shell_input .= "$sc_ip ";

    $src_vmk_nics = $src_host->getVnics();
    $shell_input .= count($src_vmk_nics)." ";
    $src_vmk_types = $src_host->getVnicsType();	

    $dest_vmk_nics = $dest_host->getVnics();
    $shell_input .= count($dest_vmk_nics)." ";
    $dest_vmk_types = $dest_host->getVnicsType();
	
    $vm_ips = $vm->getVmIp();

    $vnics_mac = $vm->getVnicsMac();
    $shell_input .= count($vnics_mac)." ";

    $fault_tolerance = 1;
    $management = 2;
    $vmotion = 4;

    foreach ($src_vmk_nics as $vmk) {
        if(empty($vmk)) continue;
   	$vmk_device = $vmk['device'];
        $vmk_mac = $vmk['spec']['mac'];
        $vmk_ip = $vmk['spec']['ip']['ipAddress'];
        $vmk_subnet = $vmk['spec']['ip']['subnetMask'];
        $shell_input .= $vmk_ip." ";
        $nicType = 0;
        
            if (!is_null($src_vmk_types['management'])&&in_array($vmk_device, $src_vmk_types['management'])) {
				$nicType= $nicType | $management;
            }

            if (!is_null($src_vmk_types['faultToleranceLogging'])&&in_array($vmk_device, $src_vmk_types['faultToleranceLogging'])) {
                   $nicType= $nicType | $fault_tolerance;
            }

            if (!is_null($src_vmk_types['vmotion'])&&in_array($vmk_device, $src_vmk_types['vmotion'])) {
                   $nicType= $nicType | $vmotion;
            }

        $shell_input .= $nicType." "; 
    }

    foreach ($dest_vmk_nics as $vmk) {
        if(empty($vmk)) continue;
	$vmk_device = $vmk['device'];
        $vmk_mac = $vmk['spec']['mac'];
        $vmk_ip = $vmk['spec']['ip']['ipAddress'];
        $vmk_subnet = $vmk['spec']['ip']['subnetMask'];
        $shell_input .= $vmk_ip." ";
	        $nicType = 0;
            if (!is_null($dest_vmk_types['management'])&&in_array($vmk_device, $dest_vmk_types['management'])) {
                   $nicType= $nicType | $management; 
            }
			
            if (!is_null($dest_vmk_types['faultToleranceLogging'])&&in_array($vmk_device, $dest_vmk_types['faultToleranceLogging'])) {
                   $nicType= $nicType | $fault_tolerance; 
            }
		    	
            if (!is_null($dest_vmk_types['vmotion'])&&in_array($vmk_device, $dest_vmk_types['vmotion'])) {
                   $nicType= $nicType | $vmotion; 
            }
		    	
        $shell_input .= $nicType." "; 
    }


    $index = 0;

    foreach ($vnics_mac as $vnic_mac) {
        $shell_input .= "$vnic_mac ";
        if (is_array($vm_ips[$index])) {
            $shell_input .= count($vm_ips[$index])." ";
            foreach ($vm_ips[$index] as $vm_ip)
                $shell_input .= "$vm_ip ";

        } else if (!empty($vm_ips[$index])) {
            $shell_input .= "1 ";
            $shell_input .= $vm_ips[$index]." ";
        } else {
            $shell_input .= "0 ";
        }
        $index++;
    }


	raslogv(VCLOG_INFO, "shell_input:$shell_input");
    global $serverport;
	publishVCenterEvents($shell_input,$serverport);

}

?>
