<?php
require_once("switch/ns.php");

class cdp {
    
    var $path;
    var $ns;
    
    function cdp()
    {
        $this->path    = "brocade_interface:protocol/cdp:cdp";
        $this->ns      = brocade_interface__ns;
        return $this;
    }
    
    function enableCdp()
    {
        return $this->maapiEnableCdp();
    }
    
    function disableCdp()
    {
        return $this->maapiDisableCdp();
    }
    
    function maapiEnableCdp()
    {
        $path = $this->path;
        $ns = $this->ns;
        $sock = maapi_connect($ns);
        $rc   = maapi_create($sock, $path);
        $ret = 0;
        if ($rc == 0) {
            $ret = maapi_apply($sock);
            if ($ret == -1) {
                raslogv(RASLOG_INFO, "CDP Global Enable failed");
            } else {
                raslogv(RASLOG_INFO, "CDP Globally Enabled");
            }
        } else {
            raslogv(VCLOG_INFO, "CDP Redundant config");
        }
        maapi_close($sock);
        return $ret;
    }
    
    function maapiDisableCdp()
    {
        $path = $this->path;
        $ns = $this->ns;
        $ret = 0;
        
        $sock = maapi_connect($ns);
        $rc   = maapi_delete($sock, $path);
        $ret   = maapi_apply($sock);
        raslogv(RASLOG_INFO, "CDP Globally Disabled");
        maapi_close($sock);
        return $ret;
    }
}

?>
