<?php
require_once("switch/ns.php");

class iface {

        var $path;

        function iface($name, $mtu = -1, $vlan = -1)
        {
                $path = "/brocade_interface:interface";
                $ns   = brocade_interface__ns;
                if (!strncmp($name, "te", 2)) {
                        $path .= "/tengigabitethernet";
                        $tuple = substr($name, 2);
                        $path .= "{" . $tuple . "}";
                }
                if (($sock = maapi_connect($ns)) == -1) {
                        echo "maapi_connect: failed";
                        return -1;
                }
                $rc = maapi_create($sock, $path);
                $rc = maapi_apply($sock);
                maapi_close($sock);
                $this->path = $path;
                return $this;
        }
        function setPortProfilePort()
        {
                echo "setPortProfile()";
                $path = $this->path;
                $sock = maapi_connect($ns);
                $rc = maapi_create($sock, $path . "/port-profile-port");
                if ($rc == 0) {
                        $rc = maapi_apply($sock);
                }
                maapi_close($sock);
                echo "=$rc     PATH=$this->path\n";
                return $rc;
                
        }
        function unSetPortProfilePort($pp)
        {
                $path = $this->path;
                $sock = maapi_connect($ns);
                $rc = maapi_delete($sock, $path . "/port-profile-port");
                $rc = maapi_apply($sock);
                maapi_close($sock);
                
        }
        function setMtu($mtu)
        {
                $path = $this->path;
                $sock = maapi_connect($ns);
                $rc = maapi_set_elem2($sock, $path . "/mtu", "$mtu");
                $rc = maapi_apply($sock);
                maapi_close($sock);
                
        }
        function getVlan()
        {
                $path = $this->path;
                $sock = maapi_connect($ns);
                $rc = maapi_get_elem2($sock, $path . "/switchport/access/vlan");
                maapi_close($sock);
                return $rc;
                //print_r($rc);
        }
        function setVlan($vlan)
        {
                $sock = maapi_connect($ns);
                $path = $this->path;

                $path .= "/switchport/basic";
                //$rc = maapi_set_elem($sock, $path, "{"."}");
                //$rc = maapi_set_elem2($sock, $this->path . "/switchport", "basic");
                //$rc = maapi_create($sock, $path);

                $path = $this->path;

                $path .= "/switchport";
                $rc = maapi_create($sock, $path);
                $path .= "/access";
                $rc = maapi_create($sock, $path);
                $path .= "/vlan";
                $rc = maapi_set_elem2($sock, $path, $vlan);
                $rc = maapi_apply($sock);
                maapi_close($sock);
        }
}

class interfaceVlan {

        var $path;
        var $vlans;
        var $ns;

        function interfaceVlan()
        {
                $this->path = "/brocade_interface:interface-vlan/interface/vlan";
                $this->ns = brocade_vlan__ns;
                $vlans = array();
                for($i = 0; $i< 4095; $i++) $vlans[$i] = 0;
                $this->vlans = $vlans;
        }

        function createInterfaceVlan($sock, $from, $to = 0)
        {
                //echo "createInterfaceVlan($from, $to)\n";
                $path = $this->path;
                $ns = $this->ns;
                if ($to < $from) return -1;
                //raslogv(RASLOG_INFO, "Create Vlans [$from-$to]");
                for ($i = $from; $i <= $to; $i++) {

                        if ($i > 3583) continue;
                        if ($this->vlans[$i] == 1) continue;
                        $this->vlans[$i] = 1;

                        $tid = maapi_start($sock, $ns);
                        $vpath = $path . "{". $i . "}";
                        //echo $vpath;
                        $rc = maapi_create($sock, $vpath);
                        //echo "Rc=$rc \n";
                        $rc = maapi_apply($sock);
                        //echo "RC=$rc \n";
                        $rc = maapi_finish($sock);;
                }
                //raslogv(RASLOG_INFO, "Created Vlans [$from-$to]");
                return 1;
        }
        function shutdown($shut, $from, $to)
        {
                echo "shutdown($shut, $from, $to)\n";
                $path = $this->path;
                $ns = $this->ns;
                if ($to < $from) return -1;
                for ($i = $from; $i <= $to; $i++) {
                        $sock = maapi_connect($ns);
                        $vpath = $path . "{". $i . "}";
                        $vpath .= "/shutdown";
                        if ($shut == 1) {
                                $rc = maapi_create($sock, $vpath);
                        } else {
                                $rc = maapi_delete($sock, $vpath);
                        }
                        $rc = maapi_apply($sock);
                        maapi_close($sock);
                }
                return 1;
        }
        function deleteInterfaceVlan($from, $to = 0)
        {
                $path = $this->path;
                $ns = $this->ns;
                if ($to == 0) $to = $from + 1;
                for ($i = $from; $i <= $to; $i++) {
                        $sock = maapi_connect($ns);
                        $vpath = $path . "{". $i . "}";
                        echo $vpath;
                        $rc = maapi_delete($sock, $vpath);
                        echo "RC=$rc \n";
                        $rc = maapi_apply($sock);
                        maapi_close($sock);
                }
        }
}
?>
