
<?php
require_once("/tmp/vcdebug_config.php");

class Logging{
    // define default log file
    //private $log_file = 'log/vnetwork.trc';
    private $log_file = LOG_FILE;
    // define file pointer
    private $fp = null;
    private $count = 0;
    private static $instance;

    private function __construct()
    {
    }

    public static function getInstance()
    {
        if (!isset(self::$instance)) {
            $className = __CLASS__;
            self::$instance = new $className;
        }
        return self::$instance;
    }

    public function increment()
    {
        return $this->count++;
    }

    public function __clone()
    {
        trigger_error('Clone is not allowed.', E_USER_ERROR);
    }

    public function __wakeup()
    {
        trigger_error('Unserializing is not allowed.', E_USER_ERROR);
    }

    // write message to the log file
    public function lwrite($message){
        try {
            // if file pointer doesn't exist, then open log file
            $fp = $this->fp;
            if (!$this->fp) $this->lopen();
            // define script name
            $cmd = 'date "+%Y/%m/%d-%H:%M:%S"';
            exec($cmd, $ret);
            //$ret = system('date "+%Y/%m/%d-%H:%M:%S"', $ctime);
            // define script name
            $script_name = pathinfo($_SERVER['PHP_SELF'], PATHINFO_FILENAME);
            fwrite($this->fp, "$ret[0]: $script_name: $message\n");

            $this->rolling();
        }catch (Exception $e) {
            $log->lclose();
        }
    }
    // open log file
    private function lopen(){
        // define log file path and name
        $lfile = $this->log_file;
        $this->fp = fopen($lfile, 'a') or exit("Can't open $lfile!");
    }
    // close log file
    public function lclose(){
        if ($this->fp == null) return;
        $lfile = $this->fp;
        fclose($this->fp);
        $this->fp = null;
    }
    // check if the file needs to be rolled 
    private function rolling(){
        // define log file path and name
        $lfile  = $this->log_file;
        $size   = filesize($lfile); // bytes 
        $maxSize  = MAX_FSIZE;
        if ($size > MAX_FSIZE) {
            $this->doRolling();
        }
    }
    // does the rolling  if the file needs to be rolled 
    private function doRolling(){
        $maxFiles = MAX_FILES;
        $lfile  = $this->log_file;
        for ($i = $maxFiles-1; $i > 1 ; $i--) {
            $prev = $i-1;
            $curr = $i;
            $this->compressAndMove($this->getFName($lfile, $prev), $this->getFName($lfile, $curr));

        }
        $this->lclose();
        $curr = 1;
        $this->compressAndMove($lfile, $this->getFName($lfile, $curr));
    }
    private function getFName($fname, $ind){
        return $fname.".".$ind; 
    }
    private function compressAndMove($fromFile, $toFile){
            try {
                if (file_exists($fromFile)) {
/*
                    // compress to a new tmp file
                    $data = implode("", file($fromFile));
                    $gzdata = gzencode($data, 9);
                    $fp = fopen($toFile.".gz", "w");
                    fwrite($fp, $gzdata);
                    fclose($fp);
*/
                    rename($fromFile, $toFile);
                } 
            }catch (Exception $e) {
                print("Error renaming $e->getMessage()\n");
            }
    }
}
?>
