<?php
require_once("switch/ns.php");

class switchport {

        var $name;
        var $ifname;
        var $iftype;
        var $path;
        var $gpath;
        var $ns;

        function switchport($name)
        {
                $this->name     = $name;
                $this->ifname   = substr($name, 3);
                $this->iftype   = substr($name, 0, 2);
                $iflongtype = "tengigabitethernet";
                if ($this->iftype === "Gi") {
                    $iflongtype = "gigabitethernet";
                } else if ($this->iftype === "Fo") {
                    $iflongtype = "fortygigabitethernet";
                }
                $this->path    = "/brocade_interface:interface/".$iflongtype."{".$this->ifname."}";
                $this->ns      = brocade_interface__ns;
                return $this;

        }
        function enableProfileMode()
        {
                return $this->maapiEnableProfileMode();
        }
        function disableProfileMode()
        {
                return $this->maapiDisableProfileMode();
        }
        function maapiEnableProfileMode()
        {
                $name = $this->name;
                $path = $this->path;
                $ns = $this->ns;
                $sock = maapi_connect($ns);
                $rc   = maapi_create($sock, $path . "/port-profile-port");
                $ret = 0;
                if ($rc == 0) {
                    $ret = maapi_apply($sock);
                    if ($ret == -1)
                        raslogv(RASLOG_ERROR, "port-profile-port configuration failed due to conflicting configuration on interface $name");
                }
                maapi_close($sock);
                $msg = "Setting port in profile mode port: $this->name $ret";
                raslogv(VCLOG_INFO, $msg);
                return $ret;
        }
        function maapiDisableProfileMode()
        {
                $path = $this->path;
                $ns = $this->ns;
                $ret = 0;

                $sock = maapi_connect($ns);
                $rc   = maapi_delete($sock, $path . "/port-profile-port");
                $ret   = maapi_apply($sock);
                maapi_close($sock);
                $msg = "UNSetting port in profile mode port: $this->name $ret";
                raslogv(VCLOG_INFO, $msg);
                return $ret;
        }
        function shutdown($shut = 1)
        {
                $path = $this->path;
                $ns = $this->ns;

                $sock = maapi_connect($ns);
                $vpath = $path . "/shutdown";
                if ($shut == 1) {
                      $rc = maapi_create($sock, $vpath);
                } else {
                      $rc = maapi_delete($sock, $vpath);
                }
                $rc = maapi_apply($sock);
                maapi_close($sock);
                return 1;
        }
        function channel_group()
        {
            $path = $this->path;
            $ns = $this->ns;

            $sock = maapi_connect($ns);
            $vpath = $path . "/channel-group/port-int";
            $rc = maapi_get_elem2($sock, $vpath);
            maapi_close($sock);
            return $rc;
        }
}

class PortChannel {

        var $name;
        var $path;
        var $gpath;

        function PortChannel($name)
        {
                $this->name     = $name;
                $this->path    = "/brocade_interface:interface/port-channel{".$name."}";
                $this->ns      = brocade_interface__ns;
                return $this;

        }
        function enableProfileMode()
        {
                return $this->maapiEnableProfileMode();
        }
        function disableProfileMode()
        {
                return $this->maapiDisableProfileMode();
        }
        function maapiEnableProfileMode()
        {
                $poname = "Po ".$this->name;
                $path = $this->path;
                $ns = $this->ns;
                $ret = 0;

                $sock = maapi_connect($ns);
                $rc   = maapi_create($sock, $path . "/port-profile-port");
                if ($rc == 0) {
                    $ret = maapi_apply($sock);
                    if ($ret == -1)
                        raslogv(RASLOG_ERROR, "port-profile-port configuration failed due to conflicting configuration on interface $poname");
                }
                maapi_close($sock);
            return $ret;
        }
        function maapiDisableProfileMode()
        {
                $path = $this->path;
                $ns = $this->ns;
                $ret = 0;

                $sock = maapi_connect($ns);
                $rc   = maapi_delete($sock, $path . "/port-profile-port");
                $ret   = maapi_apply($sock);
                maapi_close($sock);
            return $ret;
        }

        function shutdown($shut = 1)
        {
                $path = $this->path;
                $ns = $this->ns;

                $sock = maapi_connect($ns);
                $vpath = $path . "/shutdown";
                if ($shut == 1) {
                      $rc = maapi_create($sock, $vpath);
                } else {
                      $rc = maapi_delete($sock, $vpath);
                }
                $rc = maapi_apply($sock);
                maapi_close($sock);
                return 1;
        }
}
?>
